package lib;
#liblary

sub read_settings
{
  my($file)=@_;
  my @list=&hutool::OPEN_FILE();

}

sub renewal_time
{
  if( open(RENEW,">$_[0]") )
  {
    print RENEW time();
    close(RENEW);
    return 1;
  }
  return 0;
}

sub html_hw
{
  my ($val)=@_;
  my(@vals);
  my(@tags);

  while($val=~/<[\w\/\s\/\=\"\'\(\)]+>/g)
  {
    push(@tags,$&);
    push(@vals,$`);
    $val=$';
  }
  push(@vals,$val);

  foreach(@vals)
  {
    if(length($_)>4)
    {
      #最初と最後以外変換
      $_=~s/([^\w])([\w]{1,4})([^\w])/$1<span class="hw">$2<\/span>$3/g;
      #初めが変換対象の場合変換
      $_=~s/^([\w]{1,4})([^\w])/<span class="hw">$1<\/span>$2/;
      #最後が変換対象の場合変換
      $_=~s/([^\w])([\w]{1,4})$/$1<span class="hw">$2<\/span>/;
    }else
    {
      $_=~s/([\w]+)/<span class="hw">$1<\/span>/g;
    }

    if(scalar(@tags)>scalar(@vals)){$_=join('',shift(@tags),$_);}
    $_=join('',$_,shift(@tags));

  }
  $val=join('',@vals);
  return $val;
}

sub get_list
{
  my ($file)=@_;
  my @line;
  my @ret;
  my $num=0;
  if(-f $file){@line=&hutool::OPEN_FILE($file);}

  foreach(@line)
  {
    if(!($_=~/^(#|\/\/)+/) && $_=~/\=/)
    {
      $_=~/(?:\s)*([\w_]+)(?:\s)*=(?:\s)*([^\s]*)(?:\s)*/;
      if($1 eq 'number'){$num=$2;}
      $ret[$num]{$1}=$2;
    }
  }
  return @ret;
}

sub logfile_name_
{
  my($dir,$num)=@_;
  my (@time)=localtime(time());
  my $f=sprintf('%04d%02d%02d_%02d%02d%02d_',$time[5]+1900,$time[4]+1,$time[3],$time[2],$time[1],$time[0]);
  my $n=0;

  while(-f &hutool::PASS_JOIN('/',$dir,$f.$n.'.txt')){++$n;}
  return &hutool::PASS_JOIN('/',$dir,$f.$n.'.txt');
}


sub logfile_name
{
  my($dir,$num)=@_;
  my (@time)=localtime(time());
  my $f=sprintf('%02d%02d%02d_',$time[2],$time[1],$time[0]);#sprintf('%04d%02d%02d_%02d%02d%02d_',$time[5]+1900,$time[4]+1,$time[3],$time[2],$time[1],$time[0]);
  my $n=0;

  foreach($time[5]+1900,$time[4]+1,$time[3],$num)
  {
    $dir=&hutool::PASS_JOIN('/',$dir,$_);
    unless(-d $dir)
    {
      mkdir($dir,0707);
    }
  }

  while(-f &hutool::PASS_JOIN('/',$dir,$f.$n.'.txt')){++$n;}
  return &hutool::PASS_JOIN('/',$dir,$f.$n.'.txt');
}

sub get_mode
{
  my($file)=@_;
  my $line=join('',&hutool::OPEN_FILE($file));
  my %ret;
  ($ret{'mode'},$ret{'bill'},$ret{'name'},$ret{'gs'},$ret{'type'},$ret{'time'})=split(/\t|\n/,$line);
  return %ret;
}

sub out_mode
{
  my($file,$mode,$gian,$handout,$gs,$type)=@_;
  if(-f $file && open(MODE,">$file"))
  {
    my(@time)=localtime(time());
    print MODE join("\t",$mode,$gian,$handout,$gs,$type,$time[2],$time[1])."\n";
    close(MODE);
    return 1;
  }
  return 0;
}

sub log_read
{
  my($line)=@_;
  #my($time,$grade,$subject,$type,$name,$txt)=split(/\t|\n/,$line);
  #return($time,$grade,$subject,$type,$name,$txt);
  return split(/\t|\n/,$line);
}

sub make_filename
{
  my($sec,$min,$hour,$day,$month,$year,$wday)=localtime(time());
  return sprintf('%4d%02d%02d',$year+1900,$month,$day);
}

sub now_time
{
  my %time;
  ($time{'sec'},$time{'min'},$time{'hour'},$time{'day'},$time{'mon'},$time{'year'},$time{'week'})
     =localtime($_[0]);
  $time{'mon'} +=1;
  $time{'year'}+=1900;
  return %time;
}

sub add_namelist
{
  my ($file,$grade,$subject,$name)=@_;
  my $newdata='';
  my $count=0;
  my $ret=0;
  my @list=&hutool::OPEN_FILE($file);

  foreach(@list)
  {
    my @data=split(/[\t\n]/,$_);
    #count grade subject name
    if($data[1] eq $grade && $data[2] eq $subject && $data[3] eq $name)
    {
      $count=$data[0]+1;
      $newdata=join("\t",$count,@data[1..3])."\n";
      $_='';
      last;
    }
  }

  if($count==0)
  {
    $newdata=join("\t",1,$grade,$subject,$name)."\n";
    $count=1;
  }

  if($newdata ne '')
  {
    foreach(@list)
    {
      my @data=split(/[\t\n]/,$_);
      if($data[0]<=$count)
      {
        $_=$newdata.$_;
        last;
      }
    }

    if(open(NAME,">$file"))
    {
      my $line=join('',@data);
      $line=~s/(\n)+/\n/;
      print $line;
      close(NAME);
      $ret=1;
    }

  }

  return $ret;
}

sub wide2half
{
  my ($val)=@_;
  my @num=('０','１','２','３','４','５','６','７','８','９');
  my $n;
  for($n=0;$n<=9;++$n){$val=~s/$num[$n]/$n/g;}

  return $val;
}



sub log_write
{
  return 1;
}



1;
